ON_SimpleArray< T > Class Template Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_array.h>`

## Public Member Functions

| ON_SimpleArray ()
| ON_SimpleArray (int)
| ON_SimpleArray (const ON_SimpleArray< T > &)
virtual | ~ON_SimpleArray ()
virtual ON_SimpleArray< T > & | operator= (const ON_SimpleArray< T > &)
void | EmergencyDestroy (void)
int | Count () const
unsigned int | UnsignedCount () const
int | Capacity () const
unsigned int | SizeOfArray () const
unsigned int | SizeOfElement () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
T & | operator[] (int)
T & | operator[] (unsigned int)
T & | operator[] (ON__INT64)
T & | operator[] (ON__UINT64)
const T & | operator[] (int) const
const T & | operator[] (unsigned int) const
const T & | operator[] (ON__INT64) const
const T & | operator[] (ON__UINT64) const
| operator T* ()
| operator const T * () const
T * | First ()
const T * | First () const
T * | At (int)
T * | At (unsigned int)
T * | At (ON__INT64)
T * | At (ON__UINT64)
const T * | At (int) const
const T * | At (unsigned int) const
const T * | At (ON__INT64) const
const T * | At (ON__UINT64) const
T * | Last ()
const T * | Last () const
T & | AppendNew ()
void | Append (const T &)
void | Append (int, const T *)
void | Insert (int, const T &)
void | Remove ()
virtual void | Remove (int)
void | Empty ()
void | Reverse ()
void | Swap (int, int)
int | Search (const T &) const
int | Search (const T *, int(*)(const T *, const T *)) const
int | BinarySearch (const T *, int(*)(const T *, const T *)) const
int | BinarySearch (const T *, int(*)(const T *, const T *), int) const
bool | HeapSort (int(*)(const T *, const T *))
bool | QuickSort (int(*)(const T *, const T *))
bool | Sort (ON::sort_algorithm sort_algorithm, int *, int(*)(const T *, const T *)) const
bool | Sort (ON::sort_algorithm sort_algorithm, int *, int(*)(const T *, const T *, void *), void *) const
bool | Permute (const int *)
void | Zero ()
void | MemSet (unsigned char)
void | Reserve (int)
void | Shrink ()
void | Destroy ()
virtual T * | Realloc (T *, int)
T * | Array ()
const T * | Array () const
void | SetCount (int)
void | SetCapacity (int)
int | NewCapacity () const
T * | KeepArray ()
void | SetArray (T *)
void | SetArray (T *, int, int)

## Protected Member Functions

void | Move (int, int, int)

## Protected Attributes

T * | m_a
int | m_count
int | m_capacity

## Detailed Description

### template<class T>
class ON_SimpleArray< T >

Definition at line 46 of file opennurbs_array.h.

## Constructor & Destructor Documentation

## ON_SimpleArray() [1/3]

template<class T >

ON_SimpleArray< T >::ON_SimpleArray

Definition at line 65 of file opennurbs_array_defs.h.

## ON_SimpleArray() [2/3]

template<class T >

ON_SimpleArray< T >::ON_SimpleArray | ( | int | c | ) |

Definition at line 72 of file opennurbs_array_defs.h.

## ON_SimpleArray() [3/3]

template<class T >

ON_SimpleArray< T >::ON_SimpleArray | ( | const ON_SimpleArray< T > & | src | ) |

Definition at line 83 of file opennurbs_array_defs.h.

## ~ON_SimpleArray()

template<class T >

ON_SimpleArray< T >::~ON_SimpleArray

virtual

Definition at line 92 of file opennurbs_array_defs.h.

## Member Function Documentation

## Append() [1/2]

template<class T >

void ON_SimpleArray< T >::Append | ( | const T & | x | ) |

Definition at line 423 of file opennurbs_array_defs.h.

## Append() [2/2]

template<class T >

void ON_SimpleArray< T >::Append | ( | int | count,
|  | const T * | p
| ) |  |

Definition at line 450 of file opennurbs_array_defs.h.

## AppendNew()

template<class T >

T & ON_SimpleArray< T >::AppendNew

Definition at line 411 of file opennurbs_array_defs.h.

## Array() [1/2]

template<class T >

T * ON_SimpleArray< T >::Array

Definition at line 278 of file opennurbs_array_defs.h.

## Array() [2/2]

template<class T >

const T * ON_SimpleArray< T >::Array

Definition at line 284 of file opennurbs_array_defs.h.

## At() [1/8]

template<class T >

T * ON_SimpleArray< T >::At | ( | int | i | ) |

Definition at line 330 of file opennurbs_array_defs.h.

## At() [2/8]

template<class T >

const T * ON_SimpleArray< T >::At | ( | int | i | ) | const

Definition at line 342 of file opennurbs_array_defs.h.

## At() [3/8]

template<class T >

T * ON_SimpleArray< T >::At | ( | ON__INT64 | i | ) |

Definition at line 354 of file opennurbs_array_defs.h.

## At() [4/8]

template<class T >

const T * ON_SimpleArray< T >::At | ( | ON__INT64 | i | ) | const

Definition at line 366 of file opennurbs_array_defs.h.

## At() [5/8]

template<class T >

T * ON_SimpleArray< T >::At | ( | ON__UINT64 | i | ) |

Definition at line 360 of file opennurbs_array_defs.h.

## At() [6/8]

template<class T >

const T * ON_SimpleArray< T >::At | ( | ON__UINT64 | i | ) | const

Definition at line 372 of file opennurbs_array_defs.h.

## At() [7/8]

template<class T >

T * ON_SimpleArray< T >::At | ( | unsigned int | i | ) |

Definition at line 336 of file opennurbs_array_defs.h.

## At() [8/8]

template<class T >

const T * ON_SimpleArray< T >::At | ( | unsigned int | i | ) | const

Definition at line 348 of file opennurbs_array_defs.h.

## BinarySearch() [1/2]

template<class T >

int ON_SimpleArray< T >::BinarySearch | ( | const T * | key,
|  | int(*)(const T *, const T *) | compar
| ) |  | const

Definition at line 554 of file opennurbs_array_defs.h.

## BinarySearch() [2/2]

template<class T >

int ON_SimpleArray< T >::BinarySearch | ( | const T * | key,
|  | int(*)(const T *, const T *) | compar,
|  | int | count
| ) |  | const

Definition at line 600 of file opennurbs_array_defs.h.

## Capacity()

template<class T >

int ON_SimpleArray< T >::Capacity

Definition at line 142 of file opennurbs_array_defs.h.

## Count()

template<class T >

int ON_SimpleArray< T >::Count

Definition at line 130 of file opennurbs_array_defs.h.

## DataCRC()

template<class T >

ON__UINT32 ON_SimpleArray< T >::DataCRC | ( | ON__UINT32 | current_remainder | ) | const

Definition at line 161 of file opennurbs_array_defs.h.

## Destroy()

template<class T >

void ON_SimpleArray< T >::Destroy

Definition at line 749 of file opennurbs_array_defs.h.

## EmergencyDestroy()

template<class T >

void ON_SimpleArray< T >::EmergencyDestroy | ( | void |  | ) |

Definition at line 120 of file opennurbs_array_defs.h.

## Empty()

template<class T >

void ON_SimpleArray< T >::Empty

Definition at line 499 of file opennurbs_array_defs.h.

## First() [1/2]

template<class T >

T * ON_SimpleArray< T >::First

Definition at line 318 of file opennurbs_array_defs.h.

## First() [2/2]

template<class T >

const T * ON_SimpleArray< T >::First

Definition at line 324 of file opennurbs_array_defs.h.

## HeapSort()

template<class T >

bool ON_SimpleArray< T >::HeapSort | ( | int(*)(const T *, const T *) | compar | ) |

Definition at line 650 of file opennurbs_array_defs.h.

## Insert()

template<class T >

void ON_SimpleArray< T >::Insert | ( | int | i,
|  | const T & | x
| ) |  |

Definition at line 467 of file opennurbs_array_defs.h.

## KeepArray()

template<class T >

T * ON_SimpleArray< T >::KeepArray

Definition at line 290 of file opennurbs_array_defs.h.

## Last() [1/2]

template<class T >

T * ON_SimpleArray< T >::Last

Definition at line 378 of file opennurbs_array_defs.h.

## Last() [2/2]

template<class T >

const T * ON_SimpleArray< T >::Last

Definition at line 384 of file opennurbs_array_defs.h.

## MemSet()

template<class T >

void ON_SimpleArray< T >::MemSet | ( | unsigned char | value | ) |

Definition at line 726 of file opennurbs_array_defs.h.

## Move()

template<class T >

void ON_SimpleArray< T >::Move | ( | int | dest_i,
|  | int | src_i,
|  | int | ele_cnt
| ) |  |

protected

Definition at line 392 of file opennurbs_array_defs.h.

## NewCapacity()

template<class T >

int ON_SimpleArray< T >::NewCapacity

Definition at line 794 of file opennurbs_array_defs.h.

## operator const T *()

template<class T >

ON_SimpleArray< T >::operator const T *

Definition at line 272 of file opennurbs_array_defs.h.

## operator T*()

template<class T >

ON_SimpleArray< T >::operator T*

Definition at line 266 of file opennurbs_array_defs.h.

## operator=()

template<class T >

ON_SimpleArray< T > & ON_SimpleArray< T >::operator= | ( | const ON_SimpleArray< T > & | src | ) |

virtual

Definition at line 98 of file opennurbs_array_defs.h.

## operator[]() [1/8]

template<class T >

T & ON_SimpleArray< T >::operator[] | ( | int | i | ) |

Definition at line 167 of file opennurbs_array_defs.h.

## operator[]() [2/8]

template<class T >

const T & ON_SimpleArray< T >::operator[] | ( | int | i | ) | const

Definition at line 216 of file opennurbs_array_defs.h.

## operator[]() [3/8]

template<class T >

T & ON_SimpleArray< T >::operator[] | ( | ON__INT64 | i | ) |

Definition at line 192 of file opennurbs_array_defs.h.

## operator[]() [4/8]

template<class T >

const T & ON_SimpleArray< T >::operator[] | ( | ON__INT64 | i | ) | const

Definition at line 241 of file opennurbs_array_defs.h.

## operator[]() [5/8]

template<class T >

T & ON_SimpleArray< T >::operator[] | ( | ON__UINT64 | i | ) |

Definition at line 204 of file opennurbs_array_defs.h.

## operator[]() [6/8]

template<class T >

const T & ON_SimpleArray< T >::operator[] | ( | ON__UINT64 | i | ) | const

Definition at line 253 of file opennurbs_array_defs.h.

## operator[]() [7/8]

template<class T >

T & ON_SimpleArray< T >::operator[] | ( | unsigned int | i | ) |

Definition at line 179 of file opennurbs_array_defs.h.

## operator[]() [8/8]

template<class T >

const T & ON_SimpleArray< T >::operator[] | ( | unsigned int | i | ) | const

Definition at line 228 of file opennurbs_array_defs.h.

## Permute()

template<class T >

bool ON_SimpleArray< T >::Permute | ( | const int * | index | ) |

Definition at line 702 of file opennurbs_array_defs.h.

## QuickSort()

template<class T >

bool ON_SimpleArray< T >::QuickSort | ( | int(*)(const T *, const T *) | compar | ) |

Definition at line 662 of file opennurbs_array_defs.h.

## Realloc()

template<class T >

T * ON_SimpleArray< T >::Realloc | ( | T * | ptr,
|  | int | capacity
| ) |  |

virtual

Definition at line 59 of file opennurbs_array_defs.h.

## Remove() [1/2]

template<class T >

void ON_SimpleArray< T >::Remove

Definition at line 483 of file opennurbs_array_defs.h.

## Remove() [2/2]

template<class T >

void ON_SimpleArray< T >::Remove | ( | int | i | ) |

virtual

Definition at line 489 of file opennurbs_array_defs.h.

## Reserve()

template<class T >

void ON_SimpleArray< T >::Reserve | ( | int | newcap | ) |

Definition at line 736 of file opennurbs_array_defs.h.

## Reverse()

template<class T >

void ON_SimpleArray< T >::Reverse

Definition at line 507 of file opennurbs_array_defs.h.

## Search() [1/2]

template<class T >

int ON_SimpleArray< T >::Search | ( | const T & | key | ) | const

Definition at line 533 of file opennurbs_array_defs.h.

## Search() [2/2]

template<class T >

int ON_SimpleArray< T >::Search | ( | const T * | key,
|  | int(*)(const T *, const T *) | compar
| ) |  | const

Definition at line 544 of file opennurbs_array_defs.h.

## SetArray() [1/2]

template<class T >

void ON_SimpleArray< T >::SetArray | ( | T * | p | ) |

Definition at line 300 of file opennurbs_array_defs.h.

## SetArray() [2/2]

template<class T >

void ON_SimpleArray< T >::SetArray | ( | T * | p,
|  | int | count,
|  | int | capacity
| ) |  |

Definition at line 308 of file opennurbs_array_defs.h.

## SetCapacity()

template<class T >

void ON_SimpleArray< T >::SetCapacity | ( | int | capacity | ) |

Definition at line 764 of file opennurbs_array_defs.h.

## SetCount()

template<class T >

void ON_SimpleArray< T >::SetCount | ( | int | count | ) |

Definition at line 757 of file opennurbs_array_defs.h.

## Shrink()

template<class T >

void ON_SimpleArray< T >::Shrink

Definition at line 743 of file opennurbs_array_defs.h.

## SizeOfArray()

template<class T >

unsigned int ON_SimpleArray< T >::SizeOfArray

Definition at line 148 of file opennurbs_array_defs.h.

## SizeOfElement()

template<class T >

unsigned int ON_SimpleArray< T >::SizeOfElement

Definition at line 154 of file opennurbs_array_defs.h.

## Sort() [1/2]

template<class T >

bool ON_SimpleArray< T >::Sort | ( | ON::sort_algorithm | sort_algorithm,
|  | int * | index,
|  | int(*)(const T *, const T *) | compar
| ) |  | const

Definition at line 674 of file opennurbs_array_defs.h.

## Sort() [2/2]

template<class T >

bool ON_SimpleArray< T >::Sort | ( | ON::sort_algorithm | sort_algorithm,
|  | int * | index,
|  | int(*)(const T *, const T *, void *) | compar,
|  | void * | p
| ) |  | const

Definition at line 688 of file opennurbs_array_defs.h.

## Swap()

template<class T >

void ON_SimpleArray< T >::Swap | ( | int | i,
|  | int | j
| ) |  |

Definition at line 523 of file opennurbs_array_defs.h.

## UnsignedCount()

template<class T >

unsigned int ON_SimpleArray< T >::UnsignedCount

Definition at line 136 of file opennurbs_array_defs.h.

## Zero()

template<class T >

void ON_SimpleArray< T >::Zero

Definition at line 718 of file opennurbs_array_defs.h.

## Member Data Documentation

## m_a

template<class T >

T* ON_SimpleArray< T >::m_a

protected

Definition at line 351 of file opennurbs_array.h.

## m_capacity

template<class T >

int ON_SimpleArray< T >::m_capacity

protected

Definition at line 353 of file opennurbs_array.h.

## m_count

template<class T >

int ON_SimpleArray< T >::m_count

protected

Definition at line 352 of file opennurbs_array.h.

The documentation for this class was generated from the following files:

- pcl/surface/3rdparty/opennurbs/opennurbs_array.h
- pcl/surface/3rdparty/opennurbs/opennurbs_array_defs.h